'------------------------------------------------------------------------------
' File:        PnP.prg
' Purpose:     Robot Pick & Place
' Version:     1.00
' Author:      
' History:     
'------------------------------------------------------------------------------

' module global "constants"

 
' module global variables
dim shared ZeroPosition as joint of xyzr = {0 ,0 ,0 ,0}                                     'Moving as joint - for initial positioning
dim shared P1    as location of xyzr = #{376.436 , 150 , 100 ,180}                      '{X,Y,Z,R}
dim shared P11   as location of xyzr = #{376.436 , 150 , 80 ,180}
dim shared P22   as location of xyzr = #{376.436 , -150 , 80 ,180}
dim shared P2    as location of xyzr = #{376.436 , -150 , 100 ,180}
 
dim shared RobotVelocity as double = 40.0
 
program
 
    with Scara01                              'set default group element, no need to explicitly indicate the motion element
        Attach                               'Attach the task to motion element (with Scara)
            En = TRUE
            Sleep 100
            Vcruise = RobotVelocity          'Set robot's cruise velocity 
            while NOT En
                Sleep 100
            end while
            Move ZeroPosition                'moving to zero position
            WaitForMotion Scara01
              call pickPlaceXYZ              'execute Pick and Place function
            Move ZeroPosition
            WaitForMotion Scara01
        Detach
    end with    
 
end program
 
 
sub pickPlaceXYZ
 
    dim i as long
 
    Move Scara01 P11
    WaitForMotion Scara01
    Scara01.BlendingMethod = 2                  'Type of motion blending - 2 is SuperPosition blending - in order to optimize movement, so that it will be as fast as possible
    Scara01.BlendingFactor = 80                 'Percentage of the movements length that will not be blended with the next movement
    for i = 1 to 10        
        Moves Scara01 P1
        WaitForMotion Scara01
        Moves Scara01 P11
        WaitForMotion Scara01
        Moves Scara01 P22
        WaitForMotion Scara01
        Moves Scara01 P2
        WaitForMotion Scara01
        Moves Scara01 P22
        WaitForMotion Scara01
        Moves Scara01 P11 
        WaitForMotion Scara01
    next i
    Move Scara01 ZeroPosition
    WaitForMotion Scara01
 
end sub